<?php
/**
 * Edit taxonomy vocabulary
 */

require_once EQ3F_PLUGIN_PATH . 'vendor/enquir3/RemstoForm.inc';

/**
 * Form to edit a taxonomy vocabulary.
 */
class EQ3F_Feedback_Taxonomy_Edit_Form extends RemstoForm {

	/**
	 * Constructor
	 *
	 * @param type $feedback_client Feedback client.
	 * @param type $tid Taxonomy vocabulary ID.
	 */
	public function __construct( $feedback_client, $tid ) {

		$this->feedback_client = $feedback_client;
		$this->tid             = $tid;
	}

	/**
	 * Display form
	 *
	 * @return void
	 */
	public function display() {

		if ( $this->tid ) {
			$taxonomy                = $this->feedback_client->getTaxonomy( $this->tid );
			$default_display_options = RemstoClientTaxonomyDisplayOptions::selectedOptionsAsArray( $taxonomy->display_options );
		} else {
			$taxonomy                = new stdClass();
			$taxonomy->title         = '';
			$default_display_options = array();
		}

		$form_settings = array(
			'name'    => array(
				'name'  => 'taxonomy_name',
				'label' => 'Name',
				'value' => $taxonomy->title,
			),
			'display' => array(
				'name'    => 'display_options',
				'label'   => 'Diaplay Options',
				'options' => RemstoClientTaxonomyDisplayOptions::allOptionsAsArray(),
				'value'   => $default_display_options,
			),
		);

		?>
	<h2>Edit Taxonomy</h2>
	<form action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>" method="post" id="taxonomy-form" >			
		<input type="hidden" name="action" value="taxonomy_form_submit">
	<input type="hidden" name="tid" value="<?php echo esc_attr( $this->tid ); ?>">

		<?php
		$allowed_html = array(
			'form'     => array(
				'action'  => array(),
				'enctype' => array(),
				'method'  => array(),
			),
			'input'    => array(
				'id'        => array(),
				'class'     => array(),
				'type'      => array(),
				'name'      => array(),
				'value'     => array(),
				'size'      => array(),
				'maxlength' => array(),
				'checked'   => array(),
			),
			'label'    => array(
				'for' => array(),
			),
			'div'      => array(
				'class' => array(),
			),
			'span'     => array(
				'class' => array(),
				'title' => array(),
			),
			'textarea' => array(
				'id'          => array(),
				'name'        => array(),
				'class'       => array(),
				'rows'        => array(),
				'cols'        => array(),
				'placeholder' => array(),
			),
			'img'      => array(
				'src' => array(),
			),
			'h2'       => array(),
			'br'       => array(),
		);
		print wp_kses( $this->addFormTextInput( $form_settings['name'] ), $allowed_html );
		print wp_kses( $this->addFormCheckBoxGroupInput( $form_settings['display'] ), $allowed_html );
		?>

	<br>
	<input id="edit-submit" name="op" value="Save" class="form-submit" type="submit">
	<input id="edit-cancel" name="op" value="Cancel" class="form-submit" type="submit">

			</form>
		<?php
	}

}
