<?php
/**
 * Edit taxonomy term form.
 */

require_once EQ3F_PLUGIN_PATH . 'vendor/enquir3/RemstoForm.inc';

/**
 * Form to edit a taxonomy term.
 */
class EQ3F_Feedback_Taxonomy_Term_Edit_Form extends RemstoForm {


	/**
	 * Constructor
	 *
	 * @param type $feedback_client Feedback client.
	 * @param type $tid Taxonomy vocabulary ID.
	 * @param type $ttid Taxonomy term ID.
	 */
	public function __construct( $feedback_client, $tid, $ttid ) {

		$this->feedback_client = $feedback_client;
		$this->tid             = $tid;
		$this->ttid            = $ttid;
	}

	/**
	 * Display form
	 *
	 * @return void
	 */
	public function display() {

		if ( $this->ttid ) {
			$term = $this->feedback_client->getTaxonomyTermById( $this->ttid );
			if ( '0' === $term->type ) { // global.
				wp_die( 'Only local terms can be edited' );
			}
			$submit_label = 'Update';
		} else {
			$term            = new stdClass();
			$term->title     = '';
			$term->pseudonym = '';
			$submit_label    = 'Add';
		}

		$form_settings = array(
			'name' => array(
				'name'  => 'taxonomy_term_name',
				'label' => 'Name',
				'value' => $term->title,
			),
			'position' => array(
				'name'  => 'taxonomy_term_position',
				'label' => 'Position',
				'value' => $term->position,
			),
			'aka'  => array(
				'name'  => 'taxonomy_term_aka',
				'label' => 'Also known as',
				'value' => $term->pseudonym,
			),
		);
		?>
		<h2>Edit Taxonomy Terms</h2>
		<form action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>" method="post" id="taxonomy-term-form" >			
			<input type="hidden" name="action" value="taxonomy_term_form_submit">
		<input type="hidden" name="tid" value="<?php echo esc_attr( $this->tid ); ?>">
		<input type="hidden" name="ttid" value="<?php echo esc_attr( $this->ttid ); ?>">

		<?php
		$allowed_html = array(
			'form'     => array(
				'action'  => array(),
				'enctype' => array(),
				'method'  => array(),
			),
			'input'    => array(
				'id'        => array(),
				'class'     => array(),
				'type'      => array(),
				'name'      => array(),
				'value'     => array(),
				'size'      => array(),
				'maxlength' => array(),
				'checked'   => array(),
			),
			'label'    => array(
				'for' => array(),
			),
			'div'      => array(
				'class' => array(),
			),
			'span'     => array(
				'class' => array(),
				'title' => array(),
			),
			'textarea' => array(
				'id'          => array(),
				'name'        => array(),
				'class'       => array(),
				'rows'        => array(),
				'cols'        => array(),
				'placeholder' => array(),
			),
			'img'      => array(
				'src' => array(),
			),
			'h2'       => array(),
		);
		print wp_kses( $this->addFormTextInput( $form_settings['name'] ), $allowed_html );
		print wp_kses( $this->addFormTextInput( $form_settings['position'] ), $allowed_html );
		print wp_kses( $this->addFormTextInput( $form_settings['aka'] ), $allowed_html );
		?>

		<br>
		<input id="edit-submit" name="op" value="Save" class="form-submit" type="submit">
		<input id="edit-cancel" name="op" value="Cancel" class="form-submit" type="submit">

				</form>
		<?php
	}

}
