/* global RemstoAjaxClient, remsto_ajax_settings */

(function ($) {


  /** @class RemstoAjaxClient
   * Wordpress
   * Version 0.1
   */

  RemstoAjaxClient = function () {
    this.server = remsto_ajax_settings.ajax_url;
  };

  RemstoAjaxClient.prototype.getData = function (options, callback) {
    var url = this.server;

    data={
      action: 'remsto_feedback_ajax',
      options: options
    };

    $.ajax({
      url: url,
      type: "POST",
      data: data,
      dataType: "html"
    })
    .done(function (data) {
      callback(data);
    })
    .fail(function (jqXHR) {
      var err = jqXHR.status + " " + jqXHR.statusText;
      console.log(err);
    });

    return false;

  };

  RemstoAjaxClient.prototype.getFeedbackItem = function (id, callback) {

    var options = {type: "feedback_popup", id: id};
    this.getData(options, callback);
  };

  RemstoAjaxClient.prototype.sendMail = function (id, address_list, callback) {

    var options = {type: "resend_mail", id: id, al:address_list};
    this.getData(options, callback);
  };


})(jQuery);
