<?php

/**
 *
 * Remsto. Taxonomy display options
 *
 *
 * @category   Remsto
 * @package    Remsto
 * @author     Rob Bale / Ian Burnup
 * @copyright  Irun 2017
 */

if (class_exists('RemstoClientTaxonomyDisplayOptions')) {
  return;
}


class RemstoClientTaxonomyDisplayOptions {
  /*
   * Bit patterns for options
   */
  
  const LISTSERVICE = 1;
  const TAXONOMY_TERM_PAGE = 2;
  const ADVISOR_SITE = 4;
  const ALLOW_LOCAL_ADDITIONS = 8;
  /*
  const OPTION5 = 16;
  const OPTION6 = 32;
  const OPTION7 = 64;
  const OPTION8 = 128;
   * 
   */

  public static function allOptionsAsArray() {
    return array(
      RemstoClientTaxonomyDisplayOptions::LISTSERVICE => 'Show as service on lists',
      RemstoClientTaxonomyDisplayOptions::TAXONOMY_TERM_PAGE => 'Show on Taxonomy Term Page',
      RemstoClientTaxonomyDisplayOptions::ADVISOR_SITE => 'Show on Advisor Site',
      RemstoClientTaxonomyDisplayOptions::ALLOW_LOCAL_ADDITIONS => 'Allow local additions to global taxonomy',
    );
  }

  public static function selectedOptionsAsArray($stored_options) {
    
    $selected_options = array();
    
    if ($stored_options & RemstoClientTaxonomyDisplayOptions::LISTSERVICE) {
      $selected_options[] = RemstoClientTaxonomyDisplayOptions::LISTSERVICE;
    }
    
    if ($stored_options & RemstoClientTaxonomyDisplayOptions::TAXONOMY_TERM_PAGE) {
      $selected_options[] = RemstoClientTaxonomyDisplayOptions::TAXONOMY_TERM_PAGE;
    }
    
    if ($stored_options & RemstoClientTaxonomyDisplayOptions::ADVISOR_SITE) {
      $selected_options[] = RemstoClientTaxonomyDisplayOptions::ADVISOR_SITE;
    }
    
    if ($stored_options & RemstoClientTaxonomyDisplayOptions::ALLOW_LOCAL_ADDITIONS) {
      $selected_options[] = RemstoClientTaxonomyDisplayOptions::ALLOW_LOCAL_ADDITIONS;
    }
    
    return $selected_options;
  }

  public static function selectedOptionsToStore($selected_options) {
    
    $stored_options = 0;
    
    foreach ($selected_options as $selected_option) {
      $stored_options |= $selected_option;
    }
    
    return $stored_options;
  }
  
  /**
   * Test if option is set
   * @param int $display_options Display options value
   * @param int $option Option to test for
   * @return boolean
   */
  public static function isOptionSet($display_options, $option) {

    if ($display_options & $option) {
      $response = TRUE;
    }
    else {
      $response = FALSE;
    }

    return $response;
  }

}
