<?php

/**
 *
 * Remsto. Taxonomy types
 *
 *
 * @category   Remsto
 * @package    Remsto
 * @author     Ian Burnup
 * @copyright  Irun 2017
 */

if (class_exists('RemstoClientTaxonomyTypes')) {
  return;
}


class RemstoClientTaxonomyTypes {

  const GLOBAL_TAXONOMY = 0;
  const LOCAL = 1;

  /**
   * Convert Item type from int to display string
   * @param int $type Item type
   * @return string Item type display string
   */
  public static function toText($type) {

    switch ($type) {
      case RemstoClientTaxonomyTypes::GLOBAL_TAXONOMY:
        $type_string = 'Global';
        break;
      case RemstoClientTaxonomyTypes::LOCAL:
        $type_string = 'Local';
        break;     
      default:
        break;
    }

    return $type_string;
  }

  /**
   * Get an array suitable for form select elements.
   * @return array type options.
   */
  public static function getFormOptions() {

    return array(
      0 => t('Global'),
      1 => t('Local'),
    );
  }

}
