<?php

/**
 * 
 * Enquir3 Utility 
 * 
 * Provide common code to be used across different platforms/frameworks
 * Utilities for remsto system
 * 
 * @category   Remsto
 * @package    Enquir3_Library
 * @author     Ian Burnup
 * @copyright  Irun 2019
 */

if(!defined('REMSTO_PREG_CLASS_UNICODE_WORD_BOUNDARY')) {
    define('REMSTO_PREG_CLASS_UNICODE_WORD_BOUNDARY', 
'\x{0}-\x{2F}\x{3A}-\x{40}\x{5B}-\x{60}\x{7B}-\x{A9}\x{AB}-\x{B1}\x{B4}' .
  '\x{B6}-\x{B8}\x{BB}\x{BF}\x{D7}\x{F7}\x{2C2}-\x{2C5}\x{2D2}-\x{2DF}' .
  '\x{2E5}-\x{2EB}\x{2ED}\x{2EF}-\x{2FF}\x{375}\x{37E}-\x{385}\x{387}\x{3F6}' .
  '\x{482}\x{55A}-\x{55F}\x{589}-\x{58A}\x{5BE}\x{5C0}\x{5C3}\x{5C6}' .
  '\x{5F3}-\x{60F}\x{61B}-\x{61F}\x{66A}-\x{66D}\x{6D4}\x{6DD}\x{6E9}' .
  '\x{6FD}-\x{6FE}\x{700}-\x{70F}\x{7F6}-\x{7F9}\x{830}-\x{83E}' .
  '\x{964}-\x{965}\x{970}\x{9F2}-\x{9F3}\x{9FA}-\x{9FB}\x{AF1}\x{B70}' .
  '\x{BF3}-\x{BFA}\x{C7F}\x{CF1}-\x{CF2}\x{D79}\x{DF4}\x{E3F}\x{E4F}' .
  '\x{E5A}-\x{E5B}\x{F01}-\x{F17}\x{F1A}-\x{F1F}\x{F34}\x{F36}\x{F38}' .
  '\x{F3A}-\x{F3D}\x{F85}\x{FBE}-\x{FC5}\x{FC7}-\x{FD8}\x{104A}-\x{104F}' .
  '\x{109E}-\x{109F}\x{10FB}\x{1360}-\x{1368}\x{1390}-\x{1399}\x{1400}' .
  '\x{166D}-\x{166E}\x{1680}\x{169B}-\x{169C}\x{16EB}-\x{16ED}' .
  '\x{1735}-\x{1736}\x{17B4}-\x{17B5}\x{17D4}-\x{17D6}\x{17D8}-\x{17DB}' .
  '\x{1800}-\x{180A}\x{180E}\x{1940}-\x{1945}\x{19DE}-\x{19FF}' .
  '\x{1A1E}-\x{1A1F}\x{1AA0}-\x{1AA6}\x{1AA8}-\x{1AAD}\x{1B5A}-\x{1B6A}' .
  '\x{1B74}-\x{1B7C}\x{1C3B}-\x{1C3F}\x{1C7E}-\x{1C7F}\x{1CD3}\x{1FBD}' .
  '\x{1FBF}-\x{1FC1}\x{1FCD}-\x{1FCF}\x{1FDD}-\x{1FDF}\x{1FED}-\x{1FEF}' .
  '\x{1FFD}-\x{206F}\x{207A}-\x{207E}\x{208A}-\x{208E}\x{20A0}-\x{20B8}' .
  '\x{2100}-\x{2101}\x{2103}-\x{2106}\x{2108}-\x{2109}\x{2114}' .
  '\x{2116}-\x{2118}\x{211E}-\x{2123}\x{2125}\x{2127}\x{2129}\x{212E}' .
  '\x{213A}-\x{213B}\x{2140}-\x{2144}\x{214A}-\x{214D}\x{214F}' .
  '\x{2190}-\x{244A}\x{249C}-\x{24E9}\x{2500}-\x{2775}\x{2794}-\x{2B59}' .
  '\x{2CE5}-\x{2CEA}\x{2CF9}-\x{2CFC}\x{2CFE}-\x{2CFF}\x{2E00}-\x{2E2E}' .
  '\x{2E30}-\x{3004}\x{3008}-\x{3020}\x{3030}\x{3036}-\x{3037}' .
  '\x{303D}-\x{303F}\x{309B}-\x{309C}\x{30A0}\x{30FB}\x{3190}-\x{3191}' .
  '\x{3196}-\x{319F}\x{31C0}-\x{31E3}\x{3200}-\x{321E}\x{322A}-\x{3250}' .
  '\x{3260}-\x{327F}\x{328A}-\x{32B0}\x{32C0}-\x{33FF}\x{4DC0}-\x{4DFF}' .
  '\x{A490}-\x{A4C6}\x{A4FE}-\x{A4FF}\x{A60D}-\x{A60F}\x{A673}\x{A67E}' .
  '\x{A6F2}-\x{A716}\x{A720}-\x{A721}\x{A789}-\x{A78A}\x{A828}-\x{A82B}' .
  '\x{A836}-\x{A839}\x{A874}-\x{A877}\x{A8CE}-\x{A8CF}\x{A8F8}-\x{A8FA}' .
  '\x{A92E}-\x{A92F}\x{A95F}\x{A9C1}-\x{A9CD}\x{A9DE}-\x{A9DF}' .
  '\x{AA5C}-\x{AA5F}\x{AA77}-\x{AA79}\x{AADE}-\x{AADF}\x{ABEB}' .
  '\x{E000}-\x{F8FF}\x{FB29}\x{FD3E}-\x{FD3F}\x{FDFC}-\x{FDFD}' .
  '\x{FE10}-\x{FE19}\x{FE30}-\x{FE6B}\x{FEFF}-\x{FF0F}\x{FF1A}-\x{FF20}' .
  '\x{FF3B}-\x{FF40}\x{FF5B}-\x{FF65}\x{FFE0}-\x{FFFD}');
}

if (class_exists('RemstoModuleFunctions')) {
  return;
}

class RemstoModuleFunctions {
     
  /**
   * Truncate string
   * @param type $string
   * @param type $max_length
   * @param boolean $wordsafe
   * @param type $add_ellipsis
   * @param type $min_wordsafe_length
   * @return type
   */
  public static function truncate_utf8($string, $max_length, $wordsafe = FALSE, $add_ellipsis = FALSE, $min_wordsafe_length = 1) {
  $ellipsis = '';
  $max_length = max($max_length, 0);
  $min_wordsafe_length = max($min_wordsafe_length, 0);

  if (strlen($string) <= $max_length) {
    // No truncation needed, so don't add ellipsis, just return.
    return $string;
  }

  if ($add_ellipsis) {
    // Truncate ellipsis in case $max_length is small.
    $ellipsis = substr('...', 0, $max_length);
    $max_length -= strlen($ellipsis);
    $max_length = max($max_length, 0);
  }

  if ($max_length <= $min_wordsafe_length) {
    // Do not attempt word-safe if lengths are bad.
    $wordsafe = FALSE;
  }

  if ($wordsafe) {
    $matches = array();
    // Find the last word boundary, if there is one within $min_wordsafe_length
    // to $max_length characters. preg_match() is always greedy, so it will
    // find the longest string possible.
    $found = preg_match('/^(.{' . $min_wordsafe_length . ',' . $max_length . '})[' . REMSTO_PREG_CLASS_UNICODE_WORD_BOUNDARY . ']/u', $string, $matches);
    if ($found) {
      $string = $matches[1];
    }
    else {
      $string = substr($string, 0, $max_length);
    }
  }
  else {
    $string = substr($string, 0, $max_length);
  }

  if ($add_ellipsis) {
    $string .= $ellipsis;
  }

  return $string;
}
    /**
     * sanitise text
     * @param string $text data to check
     * @return string
     */   
    public static function check_plain($text) {
    return htmlspecialchars($text, ENT_QUOTES, 'UTF-8');
  }

  public static function feedback_text_value($variables) {
    if (!empty($variables['value'])) {
      // Truncate text if value given
      if (isset($variables['truncate']) && $variables['truncate'] > 0) {
        $value = self::check_plain(self::truncate_utf8($variables['value'], $variables['truncate'], true, true));
      }
      else {
        $value = self::check_plain($variables['value']);
      }
      $label = $variables['label'];
      if (isset($variables['class'])) {
        $class = $variables['class'];
      }
      else {
        $class = '';
      }

      if (isset($variables['title'])) {
        $title = $variables['title'];
      }
      else {
        $title = '';
      }
      $output = "<div class='tpp-field $class' title='$title'>";
      if ($label !== '') {
        $output .= "<span class='tpp-label'>$label</span>";
      }
      $output .= "<span class='tpp-value'>$value</span></div>";
    }
    else {
      $output = '';
    }
    return $output;
  }

  public static function feedback_icon_text_value($variables) {
    $icon_class = $variables['icon_class'];
    if (isset($variables['title'])) {
      $title = $variables['title'];
    }
    else {
      $title = '';
    }

    $output = "<div class='$icon_class' title='$title'>";
    $output .= $variables['value'];
    $output .= '</div>';

    return $output;
  }

  /**
   * Feedback more button.
   * @param type $variables
   * @return type
   */
  public static function feedback_more_button($variables) {
    
    $id = $variables['id'];
    
    if(isset($variables['label'])) {
      $label = $variables['label'];
    }
    else {
      $label = 'Read More';
    }
    
    if(isset($variables['title'])) {
      $title = $variables['title'];
    }
    else {
      $title = '';
    }
       
    $output = "<div class='remsto-more-button remsto-btn' title='$title' data-id=$id data-sid=$id>$label</div>";

    return $output;
  }
  
  public static function feedback_button($variables) {
    $id = $variables['id'];
    $label = $variables['label'];
    $title = $variables['title'];
    $class = 'remsto-btn ' . $variables['class'];

    $output = "<div class='$class' title='$title' data-id=$id data-sid=$id>$label</div>";

    return $output;
  }
  
  /**
   * Display link for feedback download
   * @param String $remote_url Remsto server URL from settings
   * @param String $printable_src File name of PDF from feedback data
   * @return string
   */
  public static function printable_src_link($remote_url, $printable_src) {
      
    $document_link = $remote_url . '/images/' . $printable_src;
          
    $output = "<div class=remsto-btn>";
    $output .= "<a href='" . $document_link . "' target='_blank' >Download Case Study</a>";
    $output .= "</div>";
     
    return $output;
          
  }
  
  

  public static function feedback_name_display($variables) {
    if ($variables['anon'] == 1 || $variables['conc'] == 1) {
      $output = 'Client details withheld';
    }
    else {
      $output = $variables['first_name'] . ' ' . $variables['last_name'];
      if (isset($variables['town']) && $variables['town'] !== '') {
        $output .= '<span class="name-comma">,&nbsp;</span>' . $variables['town'];
      }
    }
    return $output;
  }

  /**
 * Display rating stars
 * @param type $variables
 * @param type $display_value
 * @return string
 */
  public static function feedback_rating_display($variables) {
    $stars = $variables['stars'];
    $rating = $variables['rating'];
    $rating_value_text = number_format(5 * ($rating / 100), 1);
    if ( !isset( $variables[ 'display_numbers' ] ) || 'no' !== $variables[ 'display_numbers' ]) {
      $rating_value_output = "<span class='rating-value-number'>$rating_value_text</span>";
      $rating_value_output .= "<span class='rating-value-seperator'>&#47;</span>";
      $rating_value_output .= "<span class='rating-value-total'>5</span>";
    }
    else {
      $rating_value_output = "<span class='rating-value-number'></span>";
      $rating_value_output .= "<span class='rating-value-seperator'></span>";
      $rating_value_output .= "<span class='rating-value-total'></span>";
    }

    $output = '<div class="rating-widget-line">';

    $output .= '<div class="rating-widget-label">'.$variables['label'].'</div>';

    $output .= '<div class="rating-widget-stars-wrapper"><div class="rating-widget-stars">';
    for ($n = 1; $n <= $stars; $n++) {
      $star_value = ceil((100 / $stars) * $n);
      $prev_star_value = ceil((100 / $stars) * ($n - 1));
      $zebra = ($n % 2 == 0) ? 'even' : 'odd';
      $first = $n == 1 ? ' star-first' : '';
      $last = $n == $stars ? ' star-last' : '';
      $output .= '<div class="star star-' . $n . ' star-' . $zebra . $first . $last . '">';
      if ($rating < $star_value && $rating > $prev_star_value) {
        $percent = (($rating - $prev_star_value) / ($star_value - $prev_star_value)) * 100;
        $output .= '<span class="on" style="width: ' . $percent . '%">';
      }
      elseif ($rating >= $star_value) {
        $output .= '<span class="on">';
      }
      else {
        $output .= '<span class="off">';
      }
      $output .= '</span></div>';
    }
    $output .= '</div>';
    $output .= '<div class="rating-widget-value">' . $rating_value_output . '</div>';
    $output .= '</div></div>';

    return $output;
  }

  public static function calculate_rating($feedback) {
    $promised = isset($feedback->rating_promised) ? $feedback->rating_promised : 0;
    $value = isset($feedback->rating_value) ? $feedback->rating_value : 0;
    $helpful = isset($feedback->rating_helpful) ? $feedback->rating_helpful : 0;
    $communication = isset($feedback->rating_communication) ? $feedback->rating_communication : 0;

    $count = 0;
    $rating = 0;

    if ($promised > 0) {
      $rating += $promised;
      $count++;
    }

    if ($value > 0) {
      $rating += $value;
      $count++;
    }

    if ($helpful > 0) {
      $rating += $helpful;
      $count++;
    }

    if ($communication > 0) {
      $rating += $communication;
      $count++;
    }

    if ($count > 0) {
      return round($rating / $count);
    }

    return FALSE;
  }
  
 
  /**
   * Handle video/image testimonial.
   * @param type $fid
   * @param type $video_testimonial
   * @return type
   */
  public static function processVideoTestimonial($fid, $video_testimonial) {

    // Image
    if (preg_match('/^.*\.(jpg|jpeg|png|gif)$/i', $video_testimonial) > 0) {
      $testimonial_data = array(
        'button_label' => 'View Image',
        'iframe_width' => 320,
        'iframe_height' => 240,
        'iframe_border' => 0,
        'embed_src' => $video_testimonial,
        'feedback_id' => $fid,
      );
		return EQ3F_Feedback::compile_template(
			EQ3F_PLUGIN_PATH . 'views/feedback-image-testimonial.tpl.php',
			$testimonial_data );
    }
    else {
      $testimonial_data = array(
        'button_label' => 'View Video',
        'iframe_width' => 320,
        'iframe_height' => 240,
        'iframe_border' => 0,
        'embed_src' => $video_testimonial,
        'feedback_id' => $fid,
        'parsed_data' => RemstoModuleFunctions::feedbackParseVideoLink($video_testimonial),
      );
		return EQ3F_Feedback::compile_template(
			EQ3F_PLUGIN_PATH . 'views/feedback-video-testimonial.tpl.php',
			$testimonial_data );
    }
  }

  /**
   * Parse video testimonial
   * @param type $video_testimonial
   * @return type
   */
  public static function feedbackParseVideoLink($video_testimonial) {

    $matches = array();
    if (preg_match(
            "#(?<=v=)[a-zA-Z0-9-]+(?=&)|(?<=v\/)[^&\n]+|(?<=v=)[^&\n]+|(?<=youtu.be/)[^&\n]+#", $video_testimonial, $matches)) {
      $embed_code = "<iframe width='320' height='240' src='https://www.youtube.com/embed/" . $matches[0] . "' frameborder='0' allowfullscreen></iframe>";
    }
    else if (preg_match(
            "/^.*(vimeo\.com\/)((channels\/[A-z]+\/)|(groups\/[A-z]+\/videos\/))?([0-9]+)/", $video_testimonial, $matches)) {
      $embed_code = "<iframe src='//player.vimeo.com/video/" . $matches[5] . "' width='320' height='240' frameborder='0' webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>";
    }
    else {
      $embed_code = "<video width='320' height='240' controls>";
      $embed_code .= "<source src='$video_testimonial' type='video/mp4'></video>";
    }

    return $embed_code;
  }
  
  
  /**
   * Format web link
   * @param type $website
   * @return type
   */
  public static function iconWebLink( $website ) {
		$http = preg_match( '/^http[^s]/i', $website );
		if ( !$http ) {
			$website_link = "http://" . $website;
		} else {
			$website_link = $website;
		}

		$link = "<a href='" . $website_link . "' target='_blank' >Visit Website</a>";
		return self::feedback_icon_text_value( array(
			'icon_class' => 'icon-website',
			'value'		 => $link,
		) );
	}

	/**
 * Format feedback for sending as email
 * @param array $feedback_data
 * @return array formatted data
 */ 
  public static function formatForMail($feedback_data, $feedback_options) {
    
    $feedback_client = new RemstoFeedbackClient($feedback_options);

    if ($feedback_data['recommend'] == 1) {
      $feedback_data['recommend'] = 'Y';
    }
    else {
      $feedback_data['recommend'] = 'N';
    }

    $feedback_data['rating_promised'] = 5 * ($feedback_data['rating_promised'] / 100);
    $feedback_data['rating_value'] = 5 * ($feedback_data['rating_value'] / 100);
    $feedback_data['rating_helpful'] = 5 * ($feedback_data['rating_helpful'] / 100);
    $feedback_data['rating_communication'] = 5 * ($feedback_data['rating_communication'] / 100);

    $feedback_data['created'] = date('D, d M Y H:i', $feedback_data['created']);

    if (!isset($feedback_data['better'])) {
      $feedback_data['better'] = '';
    }

    $services_text = '';
    if (isset($feedback_data['services_provided'])) {
      foreach ($feedback_data['services_provided'] as $service_id) {
		if($service_id > 0) {
          $t = $feedback_client->getTaxonomyTermById($service_id);
          $services_text .= $t->title . ' ';
		}
      }
    }
    $feedback_data['services_provided'] = $services_text;

    // Staff service.
    if (isset($feedback_options['staff_taxonomy']) && $feedback_options['staff_taxonomy'] !== '0') {
      $taxonomy = $feedback_client->getTaxonomyTermById($feedback_data['staff_service']);
      $feedback_data['staff_service'] = $taxonomy->title;
    }

    // Additional Taxonomy
    $taxonomy_element = '';
    if (isset($feedback_data['taxonomy'])) { 
      foreach ($feedback_data['taxonomy'] as $tid => $taxonomy) {
        $taxonomy = $feedback_client->getTaxonomy($tid);
        $taxonomy_element .= '<div>' . $taxonomy->title . '</div>';
        $services = array();
		if ( isset( $feedback_data['taxonomy']->tid ) ) {
			foreach ($feedback_data['taxonomy']->$tid as $term_id) {
			  $term = $taxonomy->terms->$term_id;
			  $services[] = $term->title;
			}
		}
        $taxonomy_element .=  implode(", ", $services);
        $taxonomy_element .=  '<br>' ;
      }

      $feedback_data['services_text'] = $taxonomy_element;
    }

    return $feedback_data;
  }

}
