<?php
/**
 * Render a feedback form.
 */

function eq3f_render_intro_text( $vars ) {
	if( strlen($vars['options']['feedback_intro_text']['value']) > 0 ) {
		?>
		<div class="feedback-form-intro-text">
		<?php print $vars['options']['feedback_intro_text']['value']; ?>
		</div>
		<?php
	}
}

function eq3f_render_stood_out( $vars ) {
	$vars_stood_out = array(
		'name' => 'stood_out',
		'name_alt' => 'stood-out',
		'label' => $vars['options']['feedback_stood_out_label'],
		'required' => true,
		'value' => isset( $vars['stood_out'] ) ? $vars['stood_out'] : '',
		'maxlength' => $vars['options']['feedback_display_stood_out_length'],
		'length' => $vars['options']['feedback_display_stood_out_length'] - strlen( isset( $vars['stood_out'] ) ? $vars['stood_out'] : '' ),
		'description' => $vars['options']['feedback_stood_out_description'],
	);
	eq3f_render_textarea( $vars_stood_out );

	if( isset( $vars['id'] ) ) {
		if ( isset( $vars[ 'stood_out_scratchpad' ] ) && strlen( $vars[ 'stood_out_scratchpad' ] ) > 0 ) {
			$value = $vars[ 'stood_out_scratchpad' ];
		} else {
			$value = isset( $vars[ 'stood_out' ] ) ? $vars[ 'stood_out' ] : '';
		}
		$vars_stood_out_scratchpad = array(
			'name'			 => 'stood_out_scratchpad',
			'name_alt'		 => 'stood-out-scratchpad',
			'label'			 => 'Scratchpad for: ' . $vars[ 'options' ][ 'feedback_stood_out_label' ],
			'required'		 => false,
			'value'			 => $value,
			'maxlength'		 => $vars[ 'options' ][ 'feedback_display_stood_out_length' ],
			'length'		 => $vars[ 'options' ][ 'feedback_display_stood_out_length' ] - strlen( isset( $vars[ 'stood_out' ] ) ? $vars[ 'stood_out' ] : ''  ),
			'description'	 => $vars[ 'options' ][ 'feedback_stood_out_description' ],
		);
		eq3f_render_textarea( $vars_stood_out_scratchpad );
	}
}

function eq3f_render_recommend( $vars ) {
	$vars_recommend = array(
		'name' => 'recommend',
		'name_alt' => 'recommend',
		'label' => $vars['options']['feedback_recommend_label'],
		'required' => true,
		'options' => array(
			'1' => 'Yes',
			'0' => 'No',
			'-1' => 'N/A',
		),
		'selected' => isset( $vars['recommend'] ) ? $vars['recommend'] : 1,
		'description' => $vars['options']['feedback_recommend_description'],
	);
	eq3f_render_radios( $vars_recommend );
}

function eq3f_render_staff_service( $vars ) {
	if ( '0' === $vars['options']['feedback_staff_service_hidden'] || 
		 current_user_can( 'enquir3_feedback_moderate' ) ) {
		if( isset( $vars['staff_service_taxonomy_all'] ) ) {
			$vars_staff_service_taxonomy = array(
				'name' => 'staff_service',
				'name_alt' => 'staff-service',
				'label' => $vars['options']['feedback_staff_service_label'],
				'taxonomy' => $vars['staff_service_taxonomy_all'],
                                'current_selection' => isset($vars['staff_service'])?$vars['staff_service']:'',
				'description' => $vars['options']['feedback_staff_service_description'],
			);
			eq3f_render_taxonomy_select($vars_staff_service_taxonomy);
		}
		else {
			$vars_staff_service = array(
				'name' => 'staff_service',
				'name_alt' => 'staff-service',
				'label' => $vars['options']['feedback_staff_service_label'],
				'required' => false,
				'value' => isset( $vars['staff_service'] ) ? $vars['staff_service'] : '',
				'description' => $vars['options']['feedback_staff_service_description'],
			);
			eq3f_render_textfield( $vars_staff_service );
		}
	}
	else {
		$vars_staff_service = array(
			'name' => 'staff_service',
			'value' => '',
		);
		eq3f_render_hidden( $vars_staff_service );
	}
}

function eq3f_render_rating_promised( $vars ) {
	$vars_rating_promised = array(
		'name' => 'rating_promised',
		'name_alt' => 'rating-promised',
		'label' => $vars['options']['feedback_rating_promised_label'],
		'required' => true,
		'options' => array(
			'20' => '1',
			'40' => '2',
			'60' => '3',
			'80' => '4',
			'100' => '5',
			'0' => 'N/A',
		),
		'selected' => isset( $vars['rating_promised'] ) ? $vars['rating_promised'] : 100,
		'description' => $vars['options']['feedback_rating_promised_description'],
	);
	eq3f_render_radios( $vars_rating_promised );
}

function eq3f_render_rating_value( $vars ) {
	$vars_rating_value = array(
		'name' => 'rating_value',
		'name_alt' => 'rating-value',
		'label' => $vars['options']['feedback_rating_value_label'],
		'required' => true,
		'options' => array(
			'20' => '1',
			'40' => '2',
			'60' => '3',
			'80' => '4',
			'100' => '5',
			'0' => 'N/A',
		),
		'selected' => isset( $vars['rating_value'] ) ? $vars['rating_value'] : 100,
		'description' => $vars['options']['feedback_rating_value_description'],
	);
	eq3f_render_radios( $vars_rating_value );
}

function eq3f_render_rating_helpful( $vars ) {
	$vars_rating_helpful = array(
		'name' => 'rating_helpful',
		'name_alt' => 'rating-helpful',
		'label' => $vars['options']['feedback_rating_helpful_label'],
		'required' => true,
		'options' => array(
			'20' => '1',
			'40' => '2',
			'60' => '3',
			'80' => '4',
			'100' => '5',
			'0' => 'N/A',
		),
		'selected' => isset( $vars['rating_helpful'] ) ? $vars['rating_helpful'] : 100,
		'description' => $vars['options']['feedback_rating_helpful_description'],
	);
	eq3f_render_radios( $vars_rating_helpful );
}

function eq3f_render_rating_communication( $vars ) {
	$vars_rating_communication = array(
		'name' => 'rating_communication',
		'name_alt' => 'rating-communication',
		'label' => $vars['options']['feedback_rating_communication_label'],
		'required' => true,
		'options' => array(
			'20' => '1',
			'40' => '2',
			'60' => '3',
			'80' => '4',
			'100' => '5',
			'0' => 'N/A',
		),
		'selected' => isset( $vars['rating_communication'] ) ? $vars['rating_communication'] : 100,
		'description' => $vars['options']['feedback_rating_communication_description'],
	);
	eq3f_render_radios( $vars_rating_communication );
}


function eq3f_render_better( $vars ) {
	if ( '0' === $vars['options']['feedback_better_hidden'] || 
		 current_user_can( 'enquir3_feedback_moderate' ) ) {
		$vars_better = array(
			'name' => 'better',
			'name_alt' => 'better',
			'label' => $vars['options']['feedback_better_label'],
			'required' => false,
			'value' => isset( $vars['better'] ) ? $vars['better'] : '',
			'maxlength' => 2000, // $vars['display_better_length'],
			'length' => 2000 - strlen( isset( $vars['better'] ) ? $vars['better'] : '' ),
			'description' => $vars['options']['feedback_better_description'],
		);
		eq3f_render_textarea( $vars_better );
	}
	else {
		$vars_better = array(
			'name' => 'better',
			'value' => '',
		);
		eq3f_render_hidden( $vars_better );
	}
}

function eq3f_render_your_details_group( $vars ) {
	$vars_anonymous = array(
		'name' => 'anonymous',
		'name_alt' => 'anonymous',
		'label' => $vars['options']['feedback_anonymous_label'],
		'value' => $vars['anonymous_checked']
	);
	eq3f_render_checkbox( $vars_anonymous );

	$vars_concealed = array(
		'name' => 'concealed',
		'name_alt' => 'concealed',
		'label' => $vars['options']['feedback_concealed_label'],
		'value' => $vars['concealed_checked']
	);
	eq3f_render_checkbox( $vars_concealed );

	$vars_your_details = array(
		'name_alt' => 'your-details',
		'label' => $vars['options']['feedback_your_details_text'],
		'description' => $vars['options']['feedback_your_details_group_description'],
		'fields' => array(
			array(
				'function' => 'eq3f_render_textfield',
				'vars' => array(
					'name' => 'first_name',
					'name_alt' => 'first-name',
					'label' => $vars['options']['feedback_first_name_label'],
					'required' => false,
					'size' => 60,
					'maxlength' => '128',
					'value' => isset( $vars['first_name'] ) ? $vars['first_name'] : '',
				),
			),
			array(
				'function' => 'eq3f_render_textfield',
				'vars' => array(
					'name' => 'last_name',
					'name_alt' => 'last-name',
					'label' => $vars['options']['feedback_last_name_label'],
					'required' => false,
					'size' => 60,
					'maxlength' => '128',
					'value' => isset( $vars['last_name'] ) ? $vars['last_name'] : '',
				),
			),
			array(
				'function' => 'eq3f_render_textfield',
				'vars' => array(
					'name' => 'email',
					'name_alt' => 'email',
					'label' => $vars['options']['feedback_email_label'],
					'required' => false,
					'size' => 60,
					'maxlength' => '128',
					'value' => isset( $vars['email'] ) ? $vars['email'] : '',
				),
			),
		),
	);
	eq3f_render_fieldset($vars_your_details);
}

function eq3f_render_services( $vars ) {
	/* Service taxonomy */
	if ( '0' === $vars['options']['feedback_services_hidden'] || 
		 current_user_can( 'enquir3_feedback_moderate' ) ) {
		if ( isset( $vars['service_taxonomy_all'] ) ) {
			$vars_service_taxonomy = array(
				'taxonomy' => $vars['service_taxonomy_all'],
				'current_selections' => isset( $vars[ 'taxonomy' ][ $vars[ 'service_taxonomy_all' ][ 'tid' ] ] ) ? $vars[ 'taxonomy' ][ $vars[ 'service_taxonomy_all' ][ 'tid' ] ] : array(),
				'description' => $vars['options']['feedback_services_description'],
			);
			eq3f_render_taxonomy( $vars_service_taxonomy );
		}
	}
	else {
		$vars_service_taxonomy = array(
			'name' => 'vocabulary_'.$vars['service_taxonomy_all']['tid'],
			'value' => '',
		);
		eq3f_render_hidden( $vars_service_taxonomy );
	}
}

function eq3f_render_optional_group( $vars ) {
	/* Optional questions */
	if ( 'on' === $vars['options']['feedback_display_optional_fields'] ) {
		if ( '0' === $vars['options']['feedback_optional_group_hidden'] || 
			 current_user_can( 'enquir3_feedback_moderate' ) ) {
			$vars_optional_questions = array(
				'name_alt' => 'optional-group',
				'label' => $vars['options']['feedback_optional_text'],
				'description' => $vars['options']['feedback_optional_group_description'],
				'fields' => array(
					array(
						'function' => 'eq3f_render_textfield',
						'vars' => array(
							'name' => 'position',
							'name_alt' => 'position',
							'label' => $vars['options']['feedback_position_label'],
							'required' => false,
							'size' => 60,
							'maxlength' => '128',
							'value' => isset( $vars['position'] ) ? $vars['position'] : '',
						),
					),
					array(
						'function' => 'eq3f_render_textfield',
						'vars' => array(
							'name' => 'company_name',
							'name_alt' => 'company-name',
							'label' => $vars['options']['feedback_company_label'],
							'required' => false,
							'size' => 60,
							'maxlength' => '128',
							'value' => isset( $vars['company_name'] ) ? $vars['company_name'] : '',
						),
					),
					array(
						'function' => 'eq3f_render_textfield',
						'vars' => array(
							'name' => 'website',
							'name_alt' => 'website',
							'label' => $vars['options']['feedback_website_label'],
							'required' => false,
							'size' => 60,
							'maxlength' => '128',
							'value' => isset( $vars['website'] ) ? $vars['website'] : '',
						),
					),
					array(
						'function' => 'eq3f_render_textfield',
						'vars' => array(
							'name' => 'town',
							'name_alt' => 'town',
							'label' => $vars['options']['feedback_town_label'],
							'required' => false,
							'size' => 60,
							'maxlength' => '128',
							'value' => isset( $vars['town'] ) ? $vars['town'] : '',
						),
					),
					array(
						'function' => 'eq3f_render_textfield',
						'vars' => array(
							'name' => 'county',
							'name_alt' => 'county',
							'label' => $vars['options']['feedback_county_label'],
							'required' => false,
							'size' => 60,
							'maxlength' => '128',
							'value' => isset( $vars['county'] ) ? $vars['county'] : '',
						),
					),
					array(
						'function' => 'eq3f_render_textfield',
						'vars' => array(
							'name' => 'telephone',
							'name_alt' => 'telephone',
							'label' => $vars['options']['feedback_telephone_label'],
							'required' => false,
							'size' => 60,
							'maxlength' => '128',
							'value' => isset( $vars['telephone'] ) ? $vars['telephone'] : '',
						),
					),
					array(
						'function' => 'eq3f_render_textfield',
						'vars' => array(
							'name' => 'business_category',
							'name_alt' => 'business-category',
							'label' => $vars['options']['feedback_business_category_label'],
							'required' => false,
							'size' => 60,
							'maxlength' => '128',
							'value' => isset( $vars['business_category'] ) ? $vars['business_category'] : '',
						),
					),
				),
			);
			eq3f_render_fieldset($vars_optional_questions);
		}
		else {
			$vars_town = array(
				'name' => 'town',
				'value' => '',
			);
			eq3f_render_hidden( $vars_town );

			$vars_county = array(
				'name' => 'county',
				'value' => '',
			);
			eq3f_render_hidden( $vars_county );

			$vars_telephone = array(
				'name' => 'telephone',
				'value' => '',
			);
			eq3f_render_hidden( $vars_telephone );

			$vars_company_name = array(
				'name' => 'company_name',
				'value' => '',
			);
			eq3f_render_hidden( $vars_company_name );

			$vars_business_category = array(
				'name' => 'business_category',
				'value' => '',
			);
			eq3f_render_hidden( $vars_business_category );

			$vars_position = array(
				'name' => 'position',
				'value' => '',
			);
			eq3f_render_hidden( $vars_position );

			$vars_website = array(
				'name' => 'website',
				'value' => '',
			);
			eq3f_render_hidden( $vars_website );
		}
	}
}

function eq3f_render_extra_rating_questions( $vars, $i ) {
	if ( '0' === $vars['options']['feedback_extra_rating_questions_hidden'][$i] || 
		 current_user_can( 'enquir3_feedback_moderate' ) ) {
		if(strlen($vars['options']['feedback_extra_rating_questions_label'][$i])>0) {
			$vars_rating_extra = array(
				'name' => 'extra_rating_question_'.($i+1),
				'name_alt' => 'extra-rating-question-'.($i+1),
				'label' => $vars['options']['feedback_extra_rating_questions_label'][$i],
				'required' => $vars['options']['feedback_extra_rating_questions_mandatory'][$i],
				'options' => array(
					'20' => '1',
					'40' => '2',
					'60' => '3',
					'80' => '4',
					'100' => '5',
					'0' => 'N/A',
				),
				'selected' => isset( $vars['extra_rating_question_'.($i+1)] ) ? $vars['extra_rating_question_'.($i+1)] : '100',
				'description' => $vars['options']['feedback_extra_rating_questions_description'][$i],
			);
			eq3f_render_radios( $vars_rating_extra );
		}
		else {
			$vars_rating_extra = array(
				'name' => 'extra_rating_question_'.($i+1),
				'value' => 0,
			);
			eq3f_render_hidden( $vars_rating_extra );
		}
	}
	else {
		$vars_rating_extra = array(
			'name' => 'extra_rating_question_'.($i+1),
			'value' => 0,
		);
		eq3f_render_hidden( $vars_rating_extra );
	}
}

function eq3f_render_extra_worded_questions( $vars, $i ) {
	if ( '0' === $vars['options']['feedback_extra_worded_questions_hidden'][$i] || 
		 current_user_can( 'enquir3_feedback_moderate' ) ) {
		if(strlen($vars['options']['feedback_extra_worded_questions_label'][$i])>0) {
			$vars_worded_extra = array(
				'name' => 'extra_worded_question_'.($i+1),
				'name_alt' => 'extra-worded-question-'.($i+1),
				'label' => $vars['options']['feedback_extra_worded_questions_label'][$i],
				'required' => $vars['options']['feedback_extra_worded_questions_mandatory'][$i],
				'value' => isset( $vars['extra_worded_question_'.($i+1)] ) ? $vars['extra_worded_question_'.($i+1)] : '',
				'description' => $vars['options']['feedback_extra_worded_questions_description'][$i],
			);
			eq3f_render_textfield( $vars_worded_extra );
		}
		else {
			$vars_worded_extra = array(
				'name' => 'extra_worded_question_'.($i+1),
				'value' => '',
			);
			eq3f_render_hidden( $vars_worded_extra );
		}
	}
	else {
		$vars_rating_extra = array(
			'name' => 'extra_worded_question_'.($i+1),
			'value' => 0,
		);
		eq3f_render_hidden( $vars_rating_extra );
	}
}

function eq3f_render_moderation_group( $vars ) {
	$vars_moderation_group = array(
		'name_alt' => 'moderation-group',
		'label' => 'Moderation',
		'description' => $vars['options']['feedback_moderation_group_description'],
		'fields' => array(
			array(
				'function' => 'eq3f_render_hidden',
				'vars' => array(
					'name' => 'old_created',
					'value' => isset( $vars['created'] ) ? $vars['created'] : '',
				),
			),
			array(
				'function' => 'eq3f_render_fieldset',
				'vars' => array(
					'name_alt' => 'created',
					'label' => 'Created',
					'fields' => array(
						array(
							'function' => 'eq3f_render_textfield',
							'vars' => array(
								'name' => 'created[date]',
								'name_alt' => 'created-date',
								'label' => 'Date',
								'required' => false,
								'size' => 20,
								'maxlength' => '30',
								'value' => isset( $vars['created_date'] ) ? $vars['created_date'] : '',
							),
						),
						array(
							'function' => 'eq3f_render_textfield',
							'vars' => array(
								'name' => 'created[time]',
								'name_alt' => 'created-time',
								'label' => 'Time',
								'required' => false,
								'size' => 20,
								'maxlength' => '30',
								'value' => isset( $vars['created_time'] ) ? $vars['created_time'] : '',
							),
						),
					),
				),
			),
			array(
				'function' => 'eq3f_render_textarea',
				'vars' => array(
					'name' => 'company_comment',
					'name_alt' => 'company-comment',
					'label' => 'Company Comment',
					'required' => false,
					'value' => isset( $vars['company_comment'] ) ? $vars['company_comment'] : '',
					'maxlength' => $vars['feedback_display_company_comment_length'],
					'length' => $vars['feedback_display_company_comment_length'] - strlen( isset( $vars['company_comment'] ) ? $vars['company_comment'] : '' ),
				)
			),
			array(
				'function' => 'eq3f_render_textfield',
				'vars' => array(
					'name' => 'video_testimonial',
					'name_alt' => 'video-testimonial',
					'label' => 'Video Testimonial',
					'required' => false,
					'size' => 60,
					'maxlength' => '128',
					'value' => isset( $vars['video_testimonial'] ) ? $vars['video_testimonial'] : '',
				),
			),
			array(
				'function' => 'eq3f_render_textfield',
				'vars' => array(
					'name' => 'title',
					'name_alt' => 'title',
					'label' => 'Title',
					'required' => false,
					'size' => 60,
					'maxlength' => '128',
					'value' => isset( $vars['title'] ) ? $vars['title'] : '',
				),
			),
			/*array(
				'function' => 'eq3f_render_radios',
				'vars' => array(
					'name' => 'this_site_status',
					'name_alt' => 'this-site-status',
					'label' => 'Site Status',
					'required' => true,
					'options' => array(
						'0' => 'Unpublished',
						'1' => 'Published',
						'2' => 'Published and promoted',
					),
					'selected' => isset( $vars['this_site_status'] ) ? $vars['this_site_status'] : 0,
				),
			),*/
		),
	);

	foreach ( $vars[ 'site_status' ] as $site_status ) {
		if ( '0' !== $site_status->parent_id ) {
			$vars_moderation_group[ 'fields' ][] = array(
				'function' => 'eq3f_render_radios',
				'vars' => array(
					'name' => 'site_status['.$site_status->site_id.']',
					'name_alt' => 'site-status-'.$site_status->site_id,
					'label' => 'Status on site: '.$site_status->site_name,
					'required' => true,
					'options' => array(
						'0' => 'Unpublished',
						'1' => 'Published',
						'2' => 'Published and promoted',
					),
					'selected' => $site_status->status,
				),
			);
		}
	}

	eq3f_render_fieldset($vars_moderation_group);

	// Printable
	if ( empty( $vars[ 'printable_src' ] ) ) {
		$printable = array(
			'name' => 'files[feedback_printable]',
			'name_alt' => 'feedback-printable',
			'label' => 'Printable Testimonial',
			'description' => 'Upload a file, for example .pdf',
		);
		eq3f_render_file_upload( $printable );
	}
	else {
		$printable = array(
			'name_alt' => 'feedback-printable',
			'label' => 'Printable Testimonial',
			'value' => $vars[ 'printable_src' ],
		);
		eq3f_render_file_name( $printable );
	}
	$printable_name = array(
		'name' => 'printable_name',
		'value'	 => empty( $vars[ 'printable_src' ] ) ? '' : $vars[ 'printable_src' ],
	);
	eq3f_render_hidden( $printable_name );
	$orig_printable_name = array(
		'name' => 'orig_printable_name',
		'value'	 => empty( $vars[ 'printable_src' ] ) ? '' : $vars[ 'printable_src' ],
	);
	eq3f_render_hidden( $orig_printable_name );

	// Image.
	if ( empty( $vars[ 'image_src' ] ) ) {
		$image = array(
			'name' => 'files[feedback_image]',
			'name_alt' => 'feedback-image',
			'label' => 'Testimonial Image',
			'description' => 'Upload a file, for example .gif, .jpg, .bmp, .png',
		);
		eq3f_render_file_upload( $image );
	}
	else {
		$image = array(
			'name_alt' => 'feedback-image',
			'label' => 'Testimonial Image',
			'value' => $vars[ 'image_src' ],
			'src' => $vars['options']['remote_url'] . '/images/'.$vars[ 'image_src' ],
		);
		eq3f_render_file_image( $image );
	}
	$image_name = array(
		'name' => 'image_name',
		'value'	 => empty( $vars[ 'image_src' ] ) ? '' : $vars[ 'image_src' ],
	);
	eq3f_render_hidden( $image_name );
	$orig_image_name = array(
		'name' => 'orig_image_name',
		'value'	 => empty( $vars[ 'image_src' ] ) ? '' : $vars[ 'image_src' ],
	);
	eq3f_render_hidden( $orig_image_name );

	// Image Alt.
	$vars_image_alt = array(
		'name' => 'image_alt',
		'name_alt' => 'image_alt',
		'label' => 'Image Alt.',
		'required' => false,
		'value' => isset( $vars['image_alt'] ) ? $vars['image_alt'] : '',
	);
	eq3f_render_textfield( $vars_image_alt );
	
	/* Resend email */
	?>
	<button class="send-mail-button" data-id="<?php if ( isset( $vars['id'] ) ) { print $vars['id']; } ?>"
		>Resend Email
	</button>
	<div id="resend-email-dialog">
		<label for="address_list">Address list (comma separated)</label>
		<br>
		<input type="text" name="address_list" value="<?php if ( isset( $vars['address_list'] ) ) { print $vars['address_list']; } ?>"
		size="50" />
		<input type="hidden" name="id" value="" />
		<br>
		<button class="remsto-btn" id="resend-email-dialog-cancel">Cancel</button>
		<button class="remsto-btn" id="resend-email-dialog-send">Send</button>
	</div>
	<?php
	if ( isset( $vars[ 'referral_element' ] ) ) {
		print $vars[ 'referral_element' ];
	}
}


function eq3f_render_more_services( $vars, $additional_taxonomy ) {

	/* Additional taxonomy */
	if ( '0' === $vars['options']['feedback_more_services_group_hidden'][$additional_taxonomy['tid']] || 
		 current_user_can( 'enquir3_feedback_moderate' ) ) {
		$vars_additional_taxonomy = array(
			'taxonomy' => $additional_taxonomy,
			'current_selections' => isset( $vars[ 'taxonomy' ][ $additional_taxonomy[ 'tid' ] ] ) ? $vars[ 'taxonomy' ][ $additional_taxonomy[ 'tid' ] ] : array(),
			'description' => $vars['options']['feedback_more_services_group_description'][$additional_taxonomy['tid']],
		);
		eq3f_render_taxonomy( $vars_additional_taxonomy );
	}
	else {
		$vars_service_taxonomy = array(
			'name' => 'vocabulary_'.$additional_taxonomy['tid'],
			'value' => '',
		);
		eq3f_render_hidden( $vars_service_taxonomy );
	}
}
?>



<form enctype="multipart/form-data" action="" method="post" id="remsto-client-feedback-leave-feedback-form" accept-charset="UTF-8">
	<div>
		<?php
		$vars_parent_type = array(
			'name' => 'parent_type',
			'value' => 1,
		);
		eq3f_render_hidden( $vars_parent_type );
		$vars_parent_id = array(
			'name'	 => 'parent_id',
			'value'	 => $vars[ 'options' ][ 'listing_id' ],
		);
		eq3f_render_hidden( $vars_parent_id );
		$vars_feedback_id = array(
			'name' => 'feedback_id',
			'value' => isset( $vars['id'] ) ? $vars['id'] : '',
		);
		eq3f_render_hidden( $vars_feedback_id );

		// Set up an array so that the form fields can be sorted.
		$weights_functions = array(
			$vars['options']['feedback_intro_text_weight'] => array(
				'function' => 'eq3f_render_intro_text',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_stood_out_weight'] => array(
				'function' => 'eq3f_render_stood_out',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_recommend_weight'] => array(
				'function' => 'eq3f_render_recommend',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_staff_service_weight'] => array(
				'function' => 'eq3f_render_staff_service',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_staff_service_weight'] => array(
				'function' => 'eq3f_render_staff_service',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_rating_promised_weight'] => array(
				'function' => 'eq3f_render_rating_promised',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_rating_helpful_weight'] => array(
				'function' => 'eq3f_render_rating_helpful',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_rating_value_weight'] => array(
				'function' => 'eq3f_render_rating_value',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_rating_communication_weight'] => array(
				'function' => 'eq3f_render_rating_communication',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_better_weight'] => array(
				'function' => 'eq3f_render_better',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_your_details_group_weight'] => array(
				'function' => 'eq3f_render_your_details_group',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_optional_group_weight'] => array(
				'function' => 'eq3f_render_optional_group',
				'args' => array(
					$vars,
				),
			),
			$vars['options']['feedback_services_weight'] => array(
				'function' => 'eq3f_render_services',
				'args' => array(
					$vars,
				),
			),
		);

		foreach($vars['options']['feedback_extra_rating_questions_weight'] as $key => $weight) {
			$weights_functions[$weight] = array(
				'function' => 'eq3f_render_extra_rating_questions',
				'args' => array(
					$vars,
					$key,
				)
			);
		}

		foreach($vars['options']['feedback_extra_worded_questions_weight'] as $key => $weight) {
			$weights_functions[$weight] = array(
				'function' => 'eq3f_render_extra_worded_questions',
				'args' => array(
					$vars,
					$key,
				)
			);
		}

		foreach ( $vars['feedback_additional_taxonomy_all'] as $additional_taxonomy ) {
		//foreach($vars['options']['feedback_more_services_group_weight'] as $key => $weight) {
			$weights_functions[$vars['options']['feedback_more_services_group_weight'][$additional_taxonomy['tid']]] = array(
				'function' => 'eq3f_render_more_services',
				'args' => array(
					$vars,
					$additional_taxonomy,
				)
			);
		}

		// Sort the render functions by weight.
		ksort( $weights_functions );

		// Call the render functions.
		foreach($weights_functions as $function_args) {
			if ( 1 === count($function_args['args'] ) ) {
				$function_args['function']( $function_args['args'][0] );
			}
			if ( 2 === count($function_args['args'] ) ) {
				$function_args['function']( $function_args['args'][0], $function_args['args'][1] );
			}
			if ( 3 === count($function_args['args'] ) ) {
				$function_args['function']( $function_args['args'][0], $function_args['args'][1], $function_args['args'][2] );
			}
		}

		/* Moderation section */
		if ( $vars['moderation_section'] ) {
			eq3f_render_moderation_group( $vars );
		}

		/* Captcha */
		if ( isset( $vars['captcha'] ) ) {
			print $vars['captcha'];
		}
		?>
		<?php if ( isset( $vars['id'] ) ) { ?>
			<input type="submit" id="edit-submit" name="op" value="Submit" class="form-submit" />
		<?php } else { ?>
			<input type="submit" id="edit-submit" name="op"
				   value="<?php if ( isset( $vars['feedback_add_text'] ) ) { print $vars['feedback_add_text']; } ?>"
					class="form-submit" />
		<?php } ?>
	</div>

	<div id="error-msg" class="error-msg">
		<ul>
			<?php if ( isset( $vars['error_message'] ) ) { ?>
				<?php foreach($vars['error_message'] as $error_message) {?>
				<li><?php print $error_message; ?></li>
				<?php } ?>
				<script type="text/javascript">
					jQuery(document).ready(function() {
						jQuery(window).scrollTop(jQuery('#error-msg').offset().top-100);
					});
				</script>
			<?php } ?>
		</ul>
	</div>
</form>

<?php function eq3f_render_radios( $vars ) { ?>
	<div class="form-item form-type-radios form-item-<?php print $vars['name_alt']; ?>">
		<label for="edit-<?php print $vars['name_alt']; ?>"><?php print $vars['label']; ?>
		<?php if ($vars['required']) { ?>
		<span class="form-required required" title="This field is required.">*</span>
		<?php } ?>
		</label>
		<?php if (isset($vars['description'])) { ?>
		<div class="description"><?php print $vars['description'] ?></div>
		<?php } ?>
		<div id="edit-<?php print $vars['name_alt']; ?>" class="form-radios">
			<?php foreach ($vars['options'] as $value => $label) { ?>
			<div class="form-item form-type-radio form-item-<?php print $vars['name_alt']; ?>">
				<input type="radio" id="edit-<?php print $vars['name_alt']; ?>-<?php print $value; ?>" name="<?php print $vars['name']; ?>" value="<?php print $value; ?>" 
				<?php if ( strval( $value ) === $vars['selected'] ) { print 'checked'; } ?>
				class="form-radio" />
				<label class="option" for="edit-<?php print $vars['name_alt']; ?>-<?php print $value; ?>"><?php print $label; ?></label>
			</div>
			<?php } ?>
		</div>
	</div>
<?php } ?>

<?php function eq3f_render_textfield( $vars ) { ?>
	<div class="form-item form-type-textfield form-item-<?php print $vars['name_alt'] ?>">
		<label for="edit-<?php print $vars['name_alt'] ?>"><?php print $vars['label'] ?>
		<?php if ($vars['required']) { ?>
		<span class="form-required required" title="This field is required.">*</span>
		<?php } ?>
		</label>
		<?php if (isset($vars['description'])) { ?>
		<div class="description"><?php print $vars['description'] ?></div>
		<?php } ?>
		<input type="text" id="edit-<?php print $vars['name_alt'] ?>" name="<?php print $vars['name'] ?>" value="<?php print $vars['value'] ?>"
		size="<?php print $vars['size'] ?>" maxlength="<?php print $vars['maxlength'] ?>" class="form-text" />
	</div>
<?php } ?>

<?php function eq3f_render_textarea($vars) { ?>
	<div class="form-item form-type-textarea form-item-<?php print $vars['name_alt'] ?>">
		<label for="edit-<?php print $vars['name_alt'] ?>">
			<?php print $vars['label'] ?>
			<?php if ( $vars[ 'required' ] ) { ?>
				<span class="form-required required" title="This field is required.">*</span>
			<?php } ?>
		</label>
		<?php if (isset($vars['description'])) { ?>
		<div class="description"><?php print $vars['description'] ?></div>
		<?php } ?>
		<div class="form-textarea-wrapper resizable">
			<textarea maxlength="<?php print $vars['maxlength']; ?>"
			class="maxlength form-textarea" id="edit-<?php print $vars['name_alt'] ?>" name="<?php print $vars['name'] ?>" cols="60" rows="5"><?php print $vars['value']; ?></textarea>
			<div id="edit-<?php print $vars['name_alt'] ?>-counter" class="eq3f-counter">
			<?php print $vars['length']; ?> characters left.</div>
		</div>
	</div>
<?php } ?>

<?php function eq3f_render_checkbox($vars) { ?>
	<div class="form-item form-type-checkbox form-item-<?php print $vars['name_alt']; ?>">
		<input type="checkbox" id="edit-<?php print $vars['name_alt']; ?>" name="<?php print $vars['name']; ?>" value="1" class="form-checkbox" 
		<?php print $vars['value']; ?>
		/>
		<label class="option" for="edit-<?php print $vars['name_alt']; ?>"><?php print $vars['label']; ?></label>
		<?php if (isset($vars['description'])) { ?>
		<div class="description"><?php print $vars['description'] ?></div>
		<?php } ?>
	</div>
<?php } ?>

<?php function eq3f_render_hidden($vars) { ?>
	<input type="hidden" name="<?php print $vars['name']; ?>" value="<?php print $vars['value']; ?>" />
<?php } ?>

<?php function eq3f_render_fieldset($vars) { ?>
<fieldset class="form-wrapper" id="edit-<?php print $vars['name_alt']; ?>-group">
	<legend>
		<span class="fieldset-legend"><?php print $vars['label']; ?></span>
	</legend>
	<?php if (isset($vars['description'])) { ?>
	<div class="description"><?php print $vars['description'] ?></div>
	<?php } ?>
	<div class="fieldset-wrapper">
		<?php
		foreach ($vars['fields'] as $fields) {
			$fields['function']($fields['vars']);
		}
		?>
	</div>
</fieldset>

<?php } ?>

<?php function eq3f_render_taxonomy($vars) {
	$taxonomy = $vars['taxonomy'];
	$current_selections = $vars['current_selections'];

	foreach ( $taxonomy['terms'] as $term ) {
		if ( in_array( $term['term_id'], $current_selections, true ) ) {
			$taxonomy['terms'][ $term['term_id'] ]['checked'] = 'checked';
		} else {
			$taxonomy['terms'][ $term['term_id'] ]['checked'] = '';
		}
	}

	if ( isset( $taxonomy['title'] ) && isset( $taxonomy['tid'] ) && isset( $taxonomy['terms'] ) ) { ?>
	<div class="taxonomy-group">
		<div class="taxonomy-title">
			<?php print $taxonomy['title']; ?>
		</div>
		<?php if (isset($vars['description'])) { ?>
			<div class="description"><?php print $vars['description'] ?></div>
		<?php } ?>
		<div>
			<div id="edit-vocabulary-<?php print $taxonomy['tid']; ?>" class="form-checkboxes remsto_taxonomy clearfix">
				<?php foreach ( $taxonomy['terms'] as $taxonomy_term ) { ?>
				<div class="form-item form-type-checkbox form-item-vocabulary-<?php print $taxonomy['tid']; ?>-<?php print $taxonomy_term['term_id']; ?>">
					<input type="hidden" name="vocabulary_<?php print $taxonomy['tid']; ?>[<?php print $taxonomy_term['term_id']; ?>]" value="0" />
					<input
						class="remsto_taxonomy clearfix form-checkbox" id="edit-vocabulary-<?php print $taxonomy['tid']; ?>-<?php print $taxonomy_term['term_id']; ?>"
						name="vocabulary_<?php print $taxonomy['tid']; ?>[<?php print $taxonomy_term['term_id']; ?>]"
						value="<?php print $taxonomy_term['term_id']; ?>"
						type="checkbox" 
						<?php
						if ( isset( $taxonomy_term['checked'] ) ) {
							print $taxonomy_term['checked']; }
						?>
						>
					<label
						class="option" for="edit-vocabulary-<?php print $taxonomy['tid']; ?>-<?php print $taxonomy_term['term_id']; ?>">
						<?php print $taxonomy_term['title']; ?>
					</label>
				</div>
				<?php } ?>
			</div>
		</div>
	</div>
	<?php } ?>
<?php } ?>

<?php function eq3f_render_taxonomy_select($vars) {
	$taxonomy = $vars['taxonomy'];
	$current_selection = $vars['current_selection'];

	foreach ( $taxonomy['terms'] as $term ) {
		if ( $term['term_id'] == $current_selection ) {
			$taxonomy['terms'][ $term['term_id'] ]['selected'] = 'selected="selected"';
		} else {
			$taxonomy['terms'][ $term['term_id'] ]['selected'] = '';
		}
	}
	?>
    <div class='form-item form-type-select form-type-select-<?php print $vars['name_alt']; ?>'>
		<label for='edit-<?php print $vars['name_alt']; ?>'><?php print $vars['label']; ?></label>
		<?php if (isset($vars['description'])) { ?>
			<div class="description"><?php print $vars['description'] ?></div>
		<?php } ?>
		<div>
			<select id='edit-<?php print $vars['name_alt']; ?>' name='<?php print $vars['name']; ?>'>
			<?php foreach ( $taxonomy['terms'] as $taxonomy_term ) { ?>
				<option value='<?php print $taxonomy_term['term_id']; ?>' <?php print $taxonomy_term['selected']; ?>><?php print $taxonomy_term['title']; ?></option>
			<?php } ?>
			</select>
		</div>
	</div>
<?php } ?>

	

<?php function eq3f_render_file_upload( $vars ) { ?>
	<div class='field-wrapper field-<?php print $vars[ 'name_alt' ]; ?>-file'>
		<label for='edit-<?php print $vars[ 'name_alt' ]; ?>'><?php print $vars[ 'label' ]; ?></label>
		<input
			type='file'
			id='edit-<?php print $vars[ 'name_alt' ]; ?>'
			name='<?php print $vars[ 'name' ]; ?>'
			size='60'
			class='form-file'>
		<?php if ( isset( $vars[ 'description' ] ) ) { ?>
			<div class="description"><?php print $vars[ 'description' ] ?></div>
		<?php } ?>
	</div>
<?php } ?>

<?php function eq3f_render_file_name( $vars ) { ?>
	<div class='field-wrapper field-<?php print $vars[ 'name_alt' ]; ?>-file'>
		<label for='edit-<?php print $vars['name_alt']; ?>'><?php print $vars['label']; ?></label>
		<p><?php print $vars[ 'value' ]; ?></p>
		<input
			id="edit-submit-<?php print $vars[ 'name_alt' ]; ?>"
			name="edit-submit-<?php print $vars['name_alt']; ?>"
			value="Remove"
			class="form-submit"
			type="submit" />
	</div>
<?php } ?>

<?php function eq3f_render_file_image( $vars ) { ?>
	<div class='field-wrapper field-<?php print $vars[ 'name_alt' ]; ?>-file'>
		<label for='edit-<?php print $vars['name_alt']; ?>'><?php print $vars['label']; ?></label>
		<img src="<?php print $vars['src']; ?>">
		<input
			id="edit-submit-<?php print $vars[ 'name_alt' ]; ?>"
			name="edit-submit-<?php print $vars['name_alt']; ?>"
			value="Remove"
			class="form-submit"
			type="submit" />
	</div>
<?php } ?>
